Summary: Password propagation client
Name: cued-passwd
Version: 2.0
Release: 5
License: CUED
Group: CUED
Packager: John Sloan <js138@eng.cam.ac.uk>
Provides: shadow pwdutils
Source0: cued-passwd.tar.gz
Buildroot: %{_tmppath}/%{name}-build.root
BuildPreReq: gdbm-devel openssl-devel
Patch4: passwd.cued-jpmg-uid.patch

%description
Client end of CUED password propagation system.

%package -n cued-passwd-server
Summary: Password propagation server
License: CUED
Group: CUED
Packager: John Sloan <js138@eng.cam.ac.uk>
Requires: cued-passwd-admin

%description -n cued-passwd-server
Server end of CUED password propgation system.

%package -n cued-passwd-admin
Summary: Password propagation database admin tools
License: CUED
Group: CUED
Packager: John Sloan <js138@eng.cam.ac.uk>
Requires: cued-passwd

%description -n cued-passwd-admin
Database administration tools for CUED password propgation system.

%prep
%setup -n cued-passwd
pushd pam_login-3.25
./configure
popd
%patch4 -p1
%build
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/local/bin
mkdir -p $RPM_BUILD_ROOT/usr/local/sbin
mkdir -p $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/etc/cron.d
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/var/opt/passwd.cued/pwhist
mkdir -p $RPM_BUILD_ROOT/var/opt/passwd.cued/master/defaults
mkdir -p $RPM_BUILD_ROOT/usr/local/etc
mkdir -p $RPM_BUILD_ROOT/usr/local/bin
mkdir -p $RPM_BUILD_ROOT/%{_lib}/security


# our stuff
for i in passwd pin gredit pwedit
do
	install -m 0755 $i $RPM_BUILD_ROOT/usr/local/bin
done

for i in batch_edit dist_keys pwpd table warn_expire tcb2pw buildpasswd \
	conv_acct pwenc pw_older tcb_showtime client chpasswd \
	conv2tcb pw_older.run pw_older_warn warn_expire.run \
	warn_expire_pwd add_propagate getpins getwinpw passpull \
	getpasswd pwcmd
do
	install -m 0755 $i $RPM_BUILD_ROOT/usr/local/sbin
done

pushd $RPM_BUILD_ROOT/usr/local/bin
ln -sf gredit grcat
ln -sf pwedit pwcat
popd

mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m 0600 pwhist $RPM_BUILD_ROOT/etc/logrotate.d

install -m 0600 conf $RPM_BUILD_ROOT/opt/passwd.cued/etc/conf
install -m 0600 vars/hpux $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/hpux
install -m 0600 vars/linux $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/linux
install -m 0600 vars/linux-ts $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/linux-ts
install -m 0600 vars/sol2 $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/sol2
install -m 0600 vars/sol2-nh $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/sol2-nh
install -m 0600 passwd-cued-cron $RPM_BUILD_ROOT/etc/cron.d/passwd-cued-cron
install -m 0600 passwd-cued-server-cron $RPM_BUILD_ROOT/etc/cron.d
install -m 0600 passwd.proto $RPM_BUILD_ROOT/etc/passwd.proto.example
install -m 0600 passwd.proto.lnx $RPM_BUILD_ROOT/etc/passwd.proto.lnx.example
install -m 0600 passwd.proto.local $RPM_BUILD_ROOT/etc/passwd.proto.local.example
install -m 0600 group.proto $RPM_BUILD_ROOT/etc/group.proto.example
install -m 0755 useradd $RPM_BUILD_ROOT/usr/sbin
install -m 0755 groupadd $RPM_BUILD_ROOT/usr/sbin
install -m 0400 pwpio $RPM_BUILD_ROOT/etc/xinetd.d
install -m 0755 pam/pam_pwpio.so $RPM_BUILD_ROOT/%{_lib}/security

pushd $RPM_BUILD_ROOT/usr/bin
ln -sf /usr/local/bin/passwd passwd
popd

pushd $RPM_BUILD_ROOT/usr/sbin
ln -sf useradd usermod
popd

pushd $RPM_BUILD_ROOT/usr/local/etc
ln -sf /var/opt/passwd.cued uids
popd

# login, stolen vertabim from pwdutils
cd pam_login-*
make install DESTDIR=$RPM_BUILD_ROOT
cd ..

%files
/usr/local/sbin/getpasswd
/usr/local/sbin/getwinpw
/usr/local/sbin/getpins
/usr/local/sbin/passpull
/usr/local/sbin/pwcmd
/usr/local/bin/passwd
%config /etc/cron.d/passwd-cued-cron
/etc/passwd.proto.example
/etc/passwd.proto.lnx.example
/etc/passwd.proto.local.example
/etc/group.proto.example
/usr/bin/passwd
/usr/sbin/groupadd
/usr/sbin/useradd
/usr/sbin/usermod
%config /opt/passwd.cued/etc/conf
/usr/local/bin/pin
/%{_lib}/security/pam_pwpio.so
# files from pam-login
/bin/login
/etc/login.defs
/etc/pam.d/login
/usr/bin/faillog
/usr/bin/lastlog
/usr/share/locale/cs/LC_MESSAGES/pam_login.mo
/usr/share/locale/de/LC_MESSAGES/pam_login.mo
/usr/share/locale/fr/LC_MESSAGES/pam_login.mo
/usr/share/locale/nl/LC_MESSAGES/pam_login.mo
/usr/share/locale/ru/LC_MESSAGES/pam_login.mo
/usr/share/man/man1/login.1.gz
/usr/share/man/man5/faillog.5.gz
/usr/share/man/man5/lastlog.5.gz
/usr/share/man/man8/faillog.8.gz
/usr/share/man/man8/lastlog.8.gz

%files -n cued-passwd-server
%config /opt/passwd.cued/etc/vars/hpux
%config /opt/passwd.cued/etc/vars/linux
%config /opt/passwd.cued/etc/vars/linux-ts
%config /opt/passwd.cued/etc/vars/sol2
%config /opt/passwd.cued/etc/vars/sol2-nh
/usr/local/sbin/pwenc
/usr/local/sbin/pwpd
/usr/local/sbin/pw_older
%config /usr/local/sbin/pw_older.run
%config /usr/local/sbin/pw_older_warn
/usr/local/sbin/table
/usr/local/sbin/tcb_showtime
/usr/local/sbin/warn_expire
%config /usr/local/sbin/warn_expire.run
%config /usr/local/sbin/warn_expire_pwd
/usr/local/sbin/tcb2pw
/etc/xinetd.d/pwpio
/etc/cron.d/passwd-cued-server-cron
/usr/local/etc/uids

%files -n cued-passwd-admin
/usr/local/sbin/add_propagate
/usr/local/sbin/batch_edit
/usr/local/sbin/buildpasswd
/usr/local/sbin/chpasswd
/usr/local/sbin/client
/usr/local/sbin/conv2tcb
/usr/local/sbin/conv_acct
/usr/local/sbin/dist_keys
/usr/local/bin/grcat
/usr/local/bin/gredit
/usr/local/bin/pwcat
/usr/local/bin/pwedit
/etc/logrotate.d/pwhist
/var/opt/passwd.cued/pwhist

%post
cat /etc/services | grep -v pwpio >> /etc/services.new
cat >>/etc/services.new <<EOF
pwpio		619/tcp				# CUED passwd propagation
EOF
mv /etc/services.new /etc/services
cat /etc/pam.d/sshd | grep -v pam_pwpio >> /etc/pam.d/sshd.new
cat >>/etc/pam.d/sshd.new <<EOF
password required       pam_pwpio.so    try_first_pass use_authtok
EOF
mv /etc/pam.d/sshd.new /etc/pam.d/sshd
chmod 644 /etc/pam.d/sshd
